/*****************************************************
      start07.c - ST7 startup code
 ----------------------------------------------------
   Copyright (c) HIWARE AG, Basel, Switzerland
               All rights reserved               
 *****************************************************/
 
#include <hidef.h>
#include <start07.h>

#pragma DATA_SEG SHORT _ZEROPAGE

extern int _SEX;

#pragma DATA_SEG _STARTUP

_startupDesc _startupData;

static void Init (void)
  /**** Zero out global variables */
{
  _RangePtr p                 = _startupData.pZeroOut;
  unsigned int n, nofZeroOuts = _startupData.nofZeroOuts; /* << ES 03/28/95 */
  char *q;
  
  while (nofZeroOuts) {
    n = p->size;
    q = p->beg;
    while (n--) {
       *q = '\0';
       q++;
    }
    p++;
    nofZeroOuts--;
  } /* end while */;
} /* end Init */

static void Copy (void)
  /**** Copy global initialization data */
{
  _CopyPtr  p = _startupData.toCopyDownBeg;
  int       m, n = p->size;
  char *q, *far r;

  while (n) {
    q = p->dest;
    r = (char * far) (p + 1);
    m = n;
    do {
      *q = *r;
      q++; r++;
    } while (--n);
    p = (_CopyPtr) r;
    n = p->size;
  } /* end while */;
} /* end Copy */

#ifdef __cplusplus
  extern "C"
#endif
#if __STDC__
  /* ANSI does not allow interrupt keyword: have to set it in the linker parameter
     file as 'VECTOR 0 _Startup' */
void _Startup (void)
#else
void interrupt 0 _Startup (void)
#endif
  /**** Entry point of application */
{
#ifdef __cplusplus
  PROC *far funp;
#endif

#ifdef __ELF_OBJECT_FILE_FORMAT__
  DisableInterrupts;  /* in HIWARE format, this is done in the prestart code */
#endif
  for (;;) {
    asm {
                  ; Initialize stack?
                  /* << ES 12/25/94: we must always initialize SP
                  LD    A, _startupData.flags:1
                  JREQ  InitStuff
                  */
                  RSP
      InitStuff:
    } /* end asm */;

    Init ();
    Copy ();
#ifdef __cplusplus  // call global constructors
    for(funp = _startupData.mInits; *funp != NULL; funp++) {
      (*funp)();
    }
#endif    
    _startupData.main();
  } /* end for */;
} /* end _Startup */

